# NewCardFromImage

# Creates a new polymesh with the selected image source as its GL texture, alpha mask enabled.

import win32com.client
from win32com.client import constants


def XSILoadPlugin( in_reg ):
    in_reg.Author = "Tim Crowson"
    in_reg.Name = "NewCardFromImage"
    in_reg.Major = 1
    in_reg.Minor = 0
    in_reg.RegisterCommand("NewCardFromImage","NewCardFromImage")
    in_reg.RegisterMenu(constants.siMenuSEGeneralContextID,"NewCardFromImage_Menu",False,False)
    return True

def XSIUnloadPlugin( in_reg ):
    strPluginName = in_reg.Name
    Application.LogMessage(str(strPluginName) + str(" has been unloaded."),constants.siVerbose)
    return True

def NewCardFromImage_Init( in_ctxt ):
    oCmd = in_ctxt.Source
    oCmd.Description = ""
    oCmd.ReturnValue = True
    return True

def NewCardFromImage_Execute(  ):
    source = Application.Selection(0)
    if source.Type == "ImageSource":
        rawName = str(source.Name)
        name = rawName[:rawName.rfind('_')] + "_CARD"

        card = Application.CreatePrim("Grid", "MeshSurface", name, "")
        card.ulength = source.xres.Value/100
        card.vlength = source.yres.Value/100
        card.Kinematics.local.rotx = 90

        Application.CreateProjection(card, "siTxtPlanarXZ", "siTxtDefaultPlanarXZ", "", "Texture_Projection", "", "", "")
        Application.FreezeModeling(card, "", "")

        matlib = Application.ActiveProject.ActiveScene.ActiveMaterialLibrary
        mat = Application.SICreateMaterial("$XSI_DSPRESETS\\Shaders\\Material\\Phong", name, "", card, True, "")
        mat = "%s.%s"%(matlib,name)
        clip = Application.SIAddImageClip("Sources.SourwoodLeaf1_tga", "", "")[0]
        Application.NestShaders(clip, mat)
        Application.SIConnectShaderToCnxPoint(clip, "%s.surface"%mat, False)
        Application.SetValue("%s.alphamask"%mat, True)
    return True

def NewCardFromImage_Menu_Init( in_ctxt ):
    oMenu = in_ctxt.Source
    source = Application.Selection(0)
    if source.Type == "ImageSource":
        oMenu.AddCommandItem("New Card From Image","NewCardFromImage")
    return True

